<template>
  <div id="app" @keydown="appKeyDown">
    <nav>
      <div>
        <button @click="toggleTranslit" title="Вкл./Выкл. транслит [Esc]">
          <!--           <img v-if="translitEnable" src="static/icons/on.svg" />
          <img v-else src="static/icons/off.svg" />-->

          <icon name="toggle-on" v-if="translitEnable" />
          <icon name="toggle-off" v-else />
        </button>
        <button @click="spellcheck" title="Проверить орфографию [F7]" :disabled="!translitEnable">
          <icon name="spell-check" />
        </button>
        <button
          @click="copyIntoClipboard"
          title="Скопировать в буфер обмена [Ctrl+C]"
          :disabled="!translitEnable"
        >
          <icon name="copy" />
        </button>
      </div>
      <div></div>
      <div>
        <select
          id="languages"
          v-model="selected"
          @change="loadDictionary"
          title="Выбрать язык"
          :disabled="!translitEnable"
        >
          <option
            v-for="language in languages"
            :key="language.lang"
            :value="language"
          >{{language.desc}}</option>
        </select>
      </div>
    </nav>
    <div id="keymap">
      <keymapItem
        v-for="item in keymap"
        :key="item.key"
        :from="item.key"
        :to="item.value"
        :enabled="translitEnable"
        @charClicked="keymapKlicked"
      ></keymapItem>
    </div>
    <textarea
      ref="textarea"
      id="input"
      autofocus
      @keydown="translit"
      spellcheck="true"
      lang="ru_RU"
    ></textarea>
    <spellChecker ref="spellChecker" @saved="spellcheckSaved" @closed="spellcheckClosed" />
  </div>
</template>

<script>
import keymapItem from "./components/keymapItem.vue";
import spellChecker from "./components/spellChecker.vue";

export default {
  data() {
    return {
      title: "Translit",
      languages: [
        {
          lang: "ru_RU",
          desc: "Русский",
          spell: "ru",
          selected: true
        },
        {
          lang: "ua_UA",
          desc: "Українська",
          spell: "uk"
        },
        {
          lang: "be_BY",
          desc: "Беларуская",
          spell: "be"
        }
      ],
      selected: {},
      translitmap: [],
      keymap: [],
      dictionary: "",
      translitEnable: true,
      baseurl: "",
      isElectron: false
    };
  },
  created() {
    var userAgent = navigator.userAgent.toLowerCase();
    this.isElectron = userAgent.includes("electron");

    if (localStorage.getItem("language")) {
      this.selected = JSON.parse(localStorage.getItem("language"));
    } else {
      this.selected = this.languages[0];
    }
    this.loadDictionary();
  },
  methods: {
    translit(e) {
      if (e.ctrlKey || e.altKey || !this.translitEnable) {
        if (e.ctrlKey && e.code == "KeyC") {
          this.copyIntoClipboard();
        }
        return;
      }

      let textarea = e.srcElement;
      let cursor = textarea.selectionStart;
      let pre_char = textarea.value.substr(cursor - 1, 1);
      let cur_char = e.key;
      let new_char = cur_char;
      let offset = 0;

      if (pre_char != "") {
        this.translitmap.forEach(element => {
          if (element.key == pre_char + cur_char) {
            new_char = element.value;
            offset = 1;
            return;
          }
        });
      }
      if (new_char == cur_char) {
        this.translitmap.forEach(element => {
          if (element.key == cur_char) {
            new_char = element.value;
            return;
          }
        });
      }
      if (new_char != cur_char) {
        this.replaceChar(textarea, new_char, offset);
        e.preventDefault();
      }
    },
    keymapKlicked(new_char) {
      let textarea = document.getElementById("input");
      this.replaceChar(textarea, new_char, 0);
    },
    replaceChar(textarea, new_char, offset) {
      let cursorStart = textarea.selectionStart;
      let cursorEnd = textarea.selectionEnd;
      let first = textarea.value.substring(0, cursorStart - offset);
      let end = textarea.value.substring(cursorEnd, textarea.value.length);

      textarea.value = first + new_char + end;
      textarea.selectionEnd = cursorStart + 1;
      textarea.focus();
    },
    loadDictionary() {
      let url = this.baseurl + "static/dictionary/" + this.selected.lang;
      this.$http.get(url).then(function(response) {
        this.dictionary = response.data;
        this.translitmap = this.loadGroup("Translit");
        this.keymap = this.loadGroup("Keymap");

        localStorage.setItem("language", JSON.stringify(this.selected));
      });
    },
    loadGroup(group) {
      let returnValue = [];
      let lines = this.dictionary.split("\n");
      let isGroup = false;

      for (let i = 0; i < lines.length; i++) {
        let line = lines[i];
        if (!isGroup && line == "[" + group + "]") {
          isGroup = true;
          continue;
        }
        if (isGroup && line[0] != "[") {
          if (line.indexOf("=") == -1) {
            continue;
          }
          let pair = line.split("=");
          returnValue.push({ key: pair[0], value: pair[1] });
        } else if (isGroup) {
          break;
        }
      }
      return returnValue;
    },
    appKeyDown(e) {
      let spellChecker = this.$refs.spellChecker;
      if (e.code == "Escape") {
        if (spellChecker.visible) {
          spellChecker.close();
        } else {
          this.toggleTranslit();
        }
      } else if (!spellChecker.visible && e.code == "F7") {
        this.spellcheck();
      } else if (
        spellChecker.visible &&
        e.ctrlKey &&
        (e.code == "Enter" || e.code == "NumpadEnter")
      ) {
        spellChecker.close();
      }
    },
    toggleTranslit() {
      this.translitEnable = !this.translitEnable;
      this.focus();
    },
    copyIntoClipboard() {
      let textarea = document.getElementById("input");
      let cursorStart = textarea.selectionStart;
      let cursorEnd = textarea.selectionEnd;
      if (cursorStart == cursorEnd) {
        textarea.select();
      }
      document.execCommand("copy");
      textarea.selectionStart = cursorStart;
      textarea.selectionEnd = cursorEnd;
    },
    spellcheck() {
      let text = document.getElementById("input").value;
      if (text.trim().length > 0) {
        let spellChecker = this.$refs.spellChecker;
        spellChecker.show(text, this.selected);
      } else {
        this.focus();
      }
    },
    spellcheckSaved(new_text) {
      this.$refs.textarea.value = new_text;
    },
    spellcheckClosed() {
      this.focus();
    },
    focus() {
      this.$refs.textarea.focus();
    }
  },
  components: {
    keymapItem,
    spellChecker
  }
};
</script>